#!/usr/bin/python2.6
from math import log10,  log as ln

from types import LongType
from string import find,  lower,  split,  upper,  strip, rfind
from os import system,  listdir

from Numeric import dot,  zeros,  putmask,  identity,  array,  empty,  Int32,  UnsignedInt32,  Float64,  Complex64,  logical_xor,  minimum,  maximum
from Bio.KDTree import KDTree

import orange
#from orange 
import orngMDS

from genesilico.structure.BrutePDBParser import BrutePDBParser
from genesilico.structure.AATranslator import AATranslator
from genesilico.structure.SMCRA_extended import Atom,  Residue,  Chain,  Model,  Structure

import euclid
from Numeric import arccos
from math import sqrt,  log as ln

TYPE = Float64
__MAXPOW__=26

#__MAX_CACA__ =3.8

__K__ = 1.0

CM_PRED_DIR = '/home/michalp/server/SENT/'

FACTORING = 'gd2a.txt'

def cm_power(Cm2,  N, amap,  THRESHOLD=None,  PMin=0.50,  h1 = True,  h2 = False,  Clambda=1.0, FUZZY=True):#MULTICOM rough threshold
    
    if Clambda > 1:
        Cm2 = minimum(Clambda*Cm2,  zeros((N, N))+1)
    
    sep = 5+1
    cnum_native = N*(1.3461*ln(N)+3.5208)
    cnum_native = (cnum_native - N)/2 #sep = 0 non redundant half
    cnum_native = cnum_native - (N - 1) - (N - 2) #sep = 1, 2
    cnum_native = cnum_native - (1.0698*N - 14.0178) #sep = 3,4,5 - average cumm contact number
    
    #cnum_pred, P = calc_num(Cm2, N, sep, cnum_native)
    cnum_pred, Pmin = calc_num(Cm2, N, sep, cnum_native)
    
    Pmax = None
    for i in range(N):
        Pmax = max(Pmax,  max(Cm2[i]))
    
    #A = 1.0/(2.0-2*P)
    #B = (1.0-2*P)/(2.0-2*P)
    A = 0.5*1/(Pmax - Pmin)
    B = 0.5*(Pmax - 2*Pmin)/(Pmax - Pmin)
    for i in range(N):
        for j in range(N):
            if Cm2[i][j] > 0:
                if Cm2[i][j] >= Pmin:
                    Cm2[i][j] = A*Cm2[i][j]+B
                else:
                    Cm2[i][j] = 0.0
    
    print "using A,B:",  round(A, 1),  round(B, 1)
    
    if h1 == 1:
        for i in range(N-1):
            Cm2[i][i+1] = 1
            Cm2[i+1][i] = 1
            if i < N-2:
                Cm2[i][i+2] = 1
                Cm2[i+2][i] = 1
    elif h1 == 2:
        Cm2 = refine3(Cm2,  N)
    elif h1 == 3:
        Cm2 = refine4(Cm2,  N)
    
    cm= Cm2.astype(TYPE)
    
    S = 0.0
    for i in range(N):
        for j in range(i+1, N):
            if cm[i][j] > 0:
                S = S + cm[i][j]
    
    if THRESHOLD == None:
        THRESHOLD = __MAXPOW__
    
    I = 0
    K = __K__ - 0.1
    
    FUZZY = False
    
    #while abs(I - int(round(0.02*N+7.87, 0))) > 4:
    while abs(I - int(0.02*N+7.87)) > 1:
        
        K = K + 0.1
        
        distance = zeros((N, N), TYPE)
        base = identity(N, TYPE)
        zero = zeros((N, N), TYPE)
        O_val = 0
        i = 0
        Min = 0.0
        
        print "using K scale",  K
        
        while Min <= 0.5 and i < THRESHOLD:
            i = i + 1
            
            #matrix power
            #base = dot(base, cm)
            base = dot(base, cm)/K
            
            old = zeros((N, N), TYPE)
            new = zeros((N, N), TYPE)
            diff = zeros((N, N), TYPE)
            
            #new paths using probability threshold
            putmask(new, base+PMin,  1)#constant!!!
            
            if h2:
                for j in range(N-i):
                    if distance[j][j+i] == 0 and new[j][j+i] == 0:
                        new[j][j+1] = 1
                        new[j+1][j] = 1
            
            putmask(old, distance,  1)
            
            #diff - new positive entries
            putmask(diff, maximum(new-old, zero),  i)
            distance = distance + diff
            
            ###FT-COMAR
            ftc_filter = zeros((N, N))+1
            ftn_filter = zeros((N, N))
            if i == -1:
                C = 0
                NC = 0
                for k in range(N):
                    for l in range(k+3, N):
                        if distance[k][l] == 1:
                            CCNT = 0
                            for m in range(N):
                                if distance[k][m] == 1 and distance[m][l] == 1 and m != k and m !=l:
                                    CCNT = CCNT + 1
                            if CCNT < 10:
                                ftc_filter[k][l] = 0
                                ftc_filter[l][k] = 0
                            else:
                                #print "C",  CCNT
                                C = C + 2
                        elif distance[k][l] == 0:
                            NCNT = 0
                            for m in range(N):
                                if distance[k][m] == 1 and distance[m][l] == 1 and m != k and m !=l:
                                    NCNT = NCNT + 1
                            if NCNT > 18:
                                ftn_filter[k][l] = 1
                                ftn_filter[l][k] = 1
                            else:
                                #print "N",  NCNT
                                NC = NC + 2
                
                print N,  C,  NC
                putmask(distance, ftc_filter,  distance+ftn_filter)
            ###
            
            D = sum(sum(diff))
            if D > 0:
                O_val = i
            
            Min = None
            Max = None
            for c in base:
                if Min == None or min(c) < Min:
                    Min = min(c)
                if Max == None or max(c) > Max:
                    Max = max(c)
            
            print "pow", i ,  Min,  Max
            
            #"""
            if Min == 0.0 and i == THRESHOLD:
                #this code is outdated and never runs
                old = zeros((N, N), TYPE)
                new = zeros((N, N), TYPE)
                diff = zeros((N, N), TYPE)
            
                putmask(new, zeros((N, N), TYPE)+1,  1)
                putmask(old, distance,  1)
                
                putmask(diff, maximum(new-old, zero),  O_val + 1)
                distance = distance + diff
            #"""
        
        I = i
        
        if not FUZZY:
            break
    
    for j in range(N):
        distance[j][j] = 0
    
    return distance,  i,  log10(Max),  K

def refine2(Cm2,  N,  O,  TRANS):
    
    PMin = 0.51
    
    min1 = None
    neigh = 1
    max1 = -1
    for i in range(N):
        max1 = max(max1,  max(Cm2[i]))
    
    while min1 == None:
        for i in range(N-neigh):
            if Cm2[i][i+neigh] > 0:
                if min1 == None:
                    min1 = Cm2[i][i+neigh]
                else:
                    min1 = min(min1,Cm2[i][i+neigh])
        neigh = neigh + 1
        
    p = (1.0 - PMin)/(1.0 - min1)
    q = (1.0 - min1 - (1.0 - PMin))/(1.0 - min1)
    
    cm = p*Cm2 + q
    
    print 'neigh', neigh,  'min1',  min1,  'max1',  max1
    
    return cm,  max1,  neigh

def refine3(Cm2,  N):
    
    neigh = -1
    min1 = None
    while min1 == None:
        neigh = neigh + 1
        for i in range(N-neigh):
            if Cm2[i][i+neigh] > 0:
                if min1 == None:
                    min1 = Cm2[i][i+neigh]
                else:
                    min1 = min(min1,Cm2[i][i+neigh])
    neigh = neigh - 1
    
    for j in range(neigh):
        for i in range(N-neigh):
            if j < 3:
                Cm2[i][i+neigh] = 1
                Cm2[i+neigh][i] = 1
    
    return Cm2

def refine4(Cm2,  N):
    
    sep = 5+1

    cnum_native = N*(1.3461*ln(N)+3.5208)
    cnum_native = (cnum_native - N)/2 #sep = 0 non redundant half
    cnum_native = cnum_native - (N - 1) - (N - 2) #sep = 1, 2
    cnum_native = cnum_native - (1.0698*N - 14.0178) #sep = 3,4,5 - average cumm contact number
    
    cnum_pred, P,  cno = calc_num(Cm2, N, sep, cnum_native)
    
    Cm3 = zeros((N, N))
    
    for i in range(N):
        for j in range(i+sep, N):
            if Cm2[i][j] > 0:				
                p_val = Cm2[i][j]
                if p_val >= P:
                    Cm3[i][j] = 1
                    Cm3[j][i] = 1

    for i in range(N-1): #sep1
        Cm3[i][i+1] = 1
        Cm3[i+1][i] = 1
    for i in range(N-2): #sep2
        Cm3[i][i+2] = 1
        Cm3[i+2][i] = 1
    #sep 3,4,5 left empty
    #sep >= 6 taken from pred map
    
    return Cm3

def calc_num(cmap, N, sep, nn):
    
    cnum_old = 0
    delta = 0.005
    P = 1.00 + delta
    cnum = 0
    while cnum <= nn and P > 0.0:
        P = P - delta
        cnum = 0
        for i in range(N):
            for j in range(i+sep,N):
                if cmap[i][j] > 0 and cmap[i][j] >= P:
                    cnum = cnum + 1
        cnum_old = cnum
    
    if abs(cnum-nn) <= abs(cnum_old-nn):
        return cnum, P
    else:
        return cnum_old, P+delta

def refine(cm,  L,  order=25, n=None, TRANS=False):
    
    if TRANS:
        cm3= zeros((N, N), TYPE)
        
        for i in range(L):
            for j in range(i+1, L):
                if cm[i][j] == 1:
                    cm3[j-i][j] = 1
                    cm3[j][j-i] = 1
        
        for i in range(L):
            cm3[i][i] = 0.0
            #cm3[i][L-1] = 0.0 ???
            #cm3[L-1][0] = 0.0 ???
    
        return cm3,  0,  0
    
    if n == None:
        ###n = 10.0#9.73+0.003x, R2 = 0.31
        n = 1.3461*ln(L)+3.5208
        n = round(n,1)
    
    for i in range(L):
        cm[i][i] = 1.0
    S = 0.0
    for c in cm:
        S = S + sum(c)#diagonal included
    lfactor = 1.0*n*L/S#==1
    
    O = 0.0
    ############important fix!!!
    Mv = None
    for i in range(L):
        cm[i][i] = 0.0
    #################
    for c in cm:
        O = max(O, sum(c)+1)###diagonal excluded??
        Mv = max(Mv, max(c))
    
    #ofactor = (order-1)/O#because of the diagonal
    ofactor = (order + 0.0)/O
    
    #ofactor2 = lfactor*1.48-0.35#R2=0.63
    #qfactor = ofactor2/ofactor
    qfactor = lfactor/ofactor
    
    #############change!
    ############important fix!!!
    if max(abs(1.0-ofactor),  abs(1.0-lfactor)) == abs(1.0-ofactor):
        if Mv*ofactor > 1.0:
            cm = cm * min(1.0/Mv,  ofactor)
        else:
            cm = cm * ofactor
        #cm = cm * lfactor
        #############
    else:
        cm = cm * lfactor
        
    for i in range(L):
        cm[i][i] = 1.0
    
    print 'ofactor', ofactor,  'lfactor',  lfactor,  'qfactor',  qfactor,  'Mv', Mv
    
    return cm,  O,  qfactor

def crop(cm,  L,  cutoff):
    
    vval = []
    C = int((cutoff+0.0-L)/2)
    
    for i in range(L):
        for j in range(i+1, L):
            val = cm[i][j]
            if val > 0.0:
                vval.append((-val, L-abs(j-i)-1, -min(i, j), i, j,  val))#val desc, then |i-j| desc, then min (i,j) desc
    
    vval.sort()
    
    cm2 = zeros((L, L), TYPE)
    
    for rec in vval[:C]:
        a,  b,  c,  i,  j,  v = rec
        cm2[i][j] = v
        cm2[j][i] = v
    
    for i in range(L):
        cm2[i][i] = 1.0
    
    return cm2

def natural_order(L):
    
    return 10.0/L

def _cm_log(cm):
    
    N = len (cm)
    
    for i in range(N):
        for j in range(N):
            if cm[i][j]  > 1:
                cm[i][j] = log10(cm[i][j])
            else:
                cm[i][j] = 0
    
    return cm
    
def _invert(cm):
    
    Max = None
    
    for c in cm:
        if Max == None or max(c) > Max:
            Max = max(c)

    cm2 = Max - cm
    
    return cm2

def compute_atom_list(model,  metric,  chains=None, RESID=False,  FORCE=False):
    """
    This function computes list of atoms for neighbourhood computation.
    
    It also returns the atom --> residue dictionary and structure (residue) size.
    """
    translator = AATranslator()
    codes_ext = translator.get_codes_extended()
    
    atom_list = []
    residue_list = []
    atom_map = []
    residue_map = []
    
    cnt = 0
    
    for chain in model.get_iterator():
        chain_id = chain.get_id()
        if chains != None and chain_id not in chains:
            continue
            
        for residue in chain.get_iterator():
            if residue.get_resname() in codes_ext:
                if not RESID:
                    residue_id =  cnt
                else:
                    residue_id =  residue.get_id()[1]-1
                if metric in ['CA', 'CB']:
                    # CA CB
                    try:
                        atom = residue[metric]
                        
                        coords = atom.get_coord()
                        atom_list.append(coords)
                        atom_map.append(residue_id)
                        residue_list.append(residue)
                        residue_map.append(residue_id)
                    except KeyError:
                        #glycine - CB
                        try:
                            if translator.get33original(residue.get_resname()) == 'GLY' or FORCE:
                                atom = residue['CA']
                                
                                coords = atom.get_coord()
                                atom_list.append(coords)
                                atom_map.append(residue_id)
                                
                                residue_list.append(residue)
                                residue_map.append(residue_id)
                            else:
                                if not FORCE:
                                    print residue.get_resname(),  "no CA"
                                    raise
                                else:
                                    #?
                                    print residue.get_resname(),  "no CA"
                                    residue_list.append(residue)
                                    residue_map.append(residue_id)
                        except:
                            if not FORCE:
                                print residue.get_resname(),  "no CB"
                                raise
                            else:
                                #?
                                print residue.get_resname(),  "no CB"
                                residue_list.append(residue)
                                residue_map.append(residue_id)
                else:
                    # heavy any
                    heavy_tofind = (metric == 'heavy')
                    for atom in residue.get_iterator():
                        if metric == 'heavy' and atom.is_hydrogen():
                            continue
                        if heavy_tofind:
                            residue_list.append(residue)
                            residue_map.append(residue_id)
                            heavy_tofind = None
                            
                        atom_map.append(residue_id)
                        
                        coords = atom.get_coord()
                        atom_list.append(coords)
                        
                cnt = cnt + 1
    
    if RESID == 0:
        size = cnt
    elif RESID == 1:
        size = max(residue_map)+1
        
    if min(atom_map) < 0:
        k = -min(atom_map)
        amp = []
        for i in atom_map:
            amp.append(i+k)
        size = size + k#!!!
    else:
        amp = atom_map
    
    return size, (atom_list, residue_list), (amp, residue_map)


def make_contact_map(model_file,  chain, metric, separation, RESID,  FORCE):
    
    print file_name, 
    parser = BrutePDBParser(SINGLEMODEL=1, UNMODIFIED_RESNAME=1)
    struct = parser.get_protein_structure(model_file)
    model = struct[0]
    
    resnames = read_sequence(model,  chain,  metric,  RESID,  FORCE)
    
    cnt = 0
    
    if chain == None:
        chains = None
    else:
        chains = [chain]
    
        ##################
        old_id = None
    
        for r in model[chain]:
            #h,  resid,  i = r.get_id()
            aa = parser.translator.get1original(r.get_resname())
            if aa == 'X':
                continue
            cnt = cnt + 1
            h,  resid,  i = r.get_id()
            if old_id == None or resid == old_id + 1:
                old_id = resid
                continue
            #######################
            continue
            #######################
            print model_file+" gap: "+str(resid)
            raise Exception, "gapped"
        ##################
    
    ##############################################
    #
    """
    if cnt > 500:
        print model_file+" long: "+str(cnt)
        raise Exception, "long"
    #"""
    
    N, list, map = compute_atom_list(model, metric,  chains,  RESID,  FORCE)
    ##############################################
    #
    """
    if N > 1000:
        print model_file+" wide: "+str(N)
        raise Exception, "long"
    #"""
    
    print N,  "running pd..."
    
    atoms_list ,  residua_list = list
    atoms_map,  residua_map = map
    
    #DISTANCE = 20.0
    DISTANCE = 8.0
    
    cm = kdcalc(atoms_list,  DISTANCE,  [], atoms_map)
    
    cm_d = {}
    for (i, j) in cm:
        cm_d[(i, j)]=1
    
    cm2 = make_matrix(N, cm_d, atoms_map, separation)
    
    return cm2,  resnames,  N,  (list,  map)

def read_contacts(cm_file):
    
    print cm_file, 
    
    cm,  seq,  r,  o,  t = parse_casp(open(cm_file).readlines())
    
    resnames,  N,  list,  map = make_resnames(seq)
    
    print N,  "fuzzy cm read..."
    
    atoms_map,  residua_map = map
    
    cm2 = make_matrix(N, cm, atoms_map, 0)

    return cm2,  resnames,  N,  (list,  map)

def make_matrix(N, cm, mapping, separation, symmetric=True):
    """This function two-dimensional matrix out of contact pair list."""
    
    matrix=zeros((N, N), TYPE)
    
    if mapping != None:
        M = len(mapping)
    else:
        M = N
    
    val_list=[]
    
    for (x, y) in cm:
        if abs(x-y) >= separation:
            val = cm[(x, y)]
            if val != 0:
                if val < 0:
                    print x,  y,  val
                    raise
                if mapping != None:
                    X = mapping[x]
                    Y = mapping[y]
                (X,Y) = (min(X,Y),max(X,Y))
                matrix[X][Y] = val
                if symmetric:
                    matrix[Y][X] = val
    
    #!! no diaginal    
    return matrix
    
def read_sequence(model,  chain_id,  metric=None,  RESID=False,  FORCE=False):
    
    resnames = {}
    if chain_id != None:
        C = [model[chain_id]]
    else:
        C = model.child_list
    
    translator = AATranslator()
    
    i = 0
    old_chain = None
    last_resseq = None
    #shift = -1 #fix!!!
    for c in C: 
        if old_chain != None and c.get_id() != old_chain:
            #shift = shift + last_resseq
            pass
        old_chain = c.get_id()
        for r in c:
            resname = r.get_resname() 
            if resname not in translator.get_codes_extended():
                continue
            aa = translator.get1letter(resname)
            try:
                ss = r.xtra['SS_PDB']
            except:
                ss = '?'
            if metric in ['CA','CB']:
                try:
                    a = r[metric]
                except KeyError:
                    if metric == 'CB' or FORCE:
                        try:
                            a = r['CA']
                        except KeyError:
                            if not FORCE:
                                raise
                            a = None
                    else:
                        raise
                        #a = None
                if a == None:
                    oc = 1.0
                    bf = 999.99
                else:
                    oc = a.get_occupancy()
                    bf = a.get_bfactor()
            else:
                oc = 1.0
                bf = 99.99
            if not RESID:
                resnames[i] = (aa, ss,  oc,  bf)
                i = i + 1
            else:
                resseq = r.get_id()[1]-1#+shift
                #last_resseq = resseq
                resnames[resseq] = (aa, ss,  oc,  bf)
    
    return resnames

def make_resnames(seqres):
    
    s = ''
    for r in seqres:
        s = s + r[7:-1]
    
    N = len(s)
    
    resnames = {}
    for i in range(N):
        resnames[i] = (s[i], '?',  1.0,  999.99)

    list = (None,  None)
    map = (range(N),  range(N))
    
    return resnames,  N,  list,  map

def kdcalc(coords, distance, het_break,mapping):
    """This is the main KDTree routine.  It computes and returns non-redundant neighbourhood pairs."""
    
    matrix = array(coords,'f')
    
    kd = KDTree(3)
    try:
        kd.set_coords(matrix)
        kd.all_search(distance)
        indices = kd.all_get_indices()
    except ValueError:#empty
        indices = array(())
    
    return indices

def encode_protmap(crecord,  seq,  remark,  other,  thr,  target=None,  method=None,  author=None):

    rowdata = []
    
    line = 'PFRMAT RR\n'
    rowdata.append(line)
    
    if other != None:
        for line in other['target']:
            rowdata.append(line)
    if other != None:
        for line in other['author']:
            rowdata.append(line)
    if other != None:
        for line in other['method']:
            rowdata.append(line)
    if remark!= None:
        rowdata = rowdata + remark
    
    rowdata = rowdata + seq
    
    line = 'MODEL 1\n'
    rowdata.append(line)
    
    N = len(crecord[0])
    
    data = []
    for x in range(N):
        for y in range(x+1, N):
        
            val = round(float(crecord[x][y]), 3)
            if val < 0:
                print x,  y,  val
                #raise
                pass
            if val > 0:
                x,  y = min(x, y),  max(x, y)
                X = x + 1
                Y = y + 1
                X,  Y = str(X),  str(Y)
                
                r1 = (3-len(X))*' '+X#
                r2 = (3-len(Y))*' '+Y#
                
                T = str(thr)
                
                Val = str(val)
                i = find(Val, '.')
                Val = Val+(4-len(Val)+i)*'0'#
                
                line = r1+' '+r2+'  0  '+T+'  '+Val+'\n'#
                data.append((-val, -abs(x-y), -x, line))
        
    data.sort()
    for (a,  b,  c,  line) in data:
        rowdata.append(line)
    
    line='END\n'
    rowdata.append(line)
    
    return rowdata

def parse_casp(rowdata, ftype='CASP', method=None):
    
    i = 0
    row = rowdata[i]
    
    T = None 
    
    seq = []
    remark= []
    other={'target':[], 'author':[],  'method':[]}
    contacts = {}
    
    in_map = False
    for row in rowdata:
        if row == '\n':
            continue
        if in_map == False:
            try:
                if ftype in ['casp','CASP']:
                    n = int(split(row)[0])
                elif ftype == 'eva':
                    if row[:5] != 'CONTC':
                        raise ValueError
                elif ftype == 'casp-like':
                    i, j, p = split(row)
                    i = int(i)
                    j = int(j)
                    p = float(p)
                in_map = True
            except ValueError:
                pass
        
        if in_map:
            #dict fill-in
            if row[:3] == 'END':
                break
            try:
                
                #if ftype == 'CASP' and row[:5] == 'MODEL'
                if ftype in ['casp','CASP']:
                    x,  y,  zero,  threshold,  val = split(row)
                elif ftype == 'eva':
                    contc,  x,  y,  ss1,  ss2,  zero,  threshold,  val = split(row)
                elif ftype == 'casp-like':
                    x, y, val = split(row)
                    threshold = 8.0#!
                x,  y = int(x),  int(y)
                #!!!
                x, y = x-1, y-1
    
                if T == None:
                    T = float(threshold)
                val = round(float(val), 5)
            except:
                raise 
            
            if contacts.has_key((x, y)):
                raise Exception
            
            if val > 0:
                contacts[(x, y)]=val
        
        else:
            #remarks
            tag = row[:6]
            
            if tag in ['PFRMAT',  'MODEL ']:
                pass
                
            elif tag in ['REMARK']:
                remark.append(row)
            
            elif tag in ['TARGET']:
                other['target'].append(row)
            elif tag in ['AUTHOR']:
                other['author'].append(row)
            elif tag in ['METHOD']:
                other['method'].append(row)
                
            elif tag in ['# job ']:
                remark.append('REMARK '+row)
        
            elif tag in ['# subm']:
                seq.append('SEQRES '+row[22:])
            
            elif row not in ['\n',  'END\n',  'END']:
                if ftype in ['casp', 'eva','CASP']:
                    if row[:6] != 'SEQRES':
                        seq.append('SEQRES '+row)
                    else:
                        #seq.append(row)
                        seq.append('SEQRES '+strip(row[7:])+'\n')
                elif ftype == 'casp-like':
                    remark.append('REMARK '+row)
        
    return (contacts,  seq,  remark,  other,  T)
    
def get_seqrecord(resnames):
    
    kys = resnames.keys()
    kys.sort()
    
    seq = ''
    for k in kys:
        seq=seq+resnames[k][0]
    
    record = []
    N = len(seq)
    i = 0
    while i*50 < N:
        line = 'SEQRES  '+seq[i*50:(i+1)*50]+'\n'
        record.append(line)
        i = i + 1
    
    return record
    
def savef(filename,  rowdata):
    
    savef =  open(filename, 'w')
    savef.writelines(rowdata)
    savef.close()

def dm_calc(coords,  N,  amap=None):
    
    n = len(coords)
    dm=zeros((N, N), 'f')
    
    for i in range(n):
        atom1 = coords[i]
        for j in range(i+1, n):
            atom2 = coords[j]
            distance = atom1-atom2
            if amap != None:
                X,  Y = amap[i],  amap[j]
            else:
                X, Y=i, j
            dm[X][Y] = distance
            ######################
            #dm[j][i] = distance
            dm[Y][X] = distance
    
    #for i in range(N):
    #    dm[i][i] = 0.0
    
    return dm

def mds2atoms(mds,  metric):
    
    atoms = []
    atoms2 = []
    name = metric
        
    for i in range(len(mds)):
        v = array((mds[i][0], mds[i][1], mds[i][2]))
        w = array((mds[i][0], mds[i][1], -mds[i][2]))
        a = Atom(name, v,  1.00,  1.00,  1.00,  name,  str(i+1))
        b = Atom(name, w,  1.00,  1.00,  1.00,  name,  str(i+1))
        #atom=self.atom=Atom(name, coord, b_factor, occupancy, altloc, fullname, serial_number)
        atoms.append(a)
        atoms2.append(b)

    return (atoms,  atoms2)

def encode_smcra(atoms,  seqres,  sname,  alter=False):
    
    translator = AATranslator()
    
    S = Structure('')
    M = Model(0)
    C = Chain(' ')
    
    seq = ''
    for s in seqres:
        seq = seq + s[8:-1]
    N = len(seq)
    
    j = rfind(sname, '/')+1
    code = upper(sname[j:j+5])
    
    for i in range(N):
        id = (' ', i+1, ' ')
        resname = translator.get3letter(seq[i])
        R = Residue(id,  resname,  code)
        atom = atoms[i]
        R.add(atom)
        C.add(R)
    
    M.add(C)
    S.add(M)
    if not alter:
        header = ['HEADER    mds                                     12-DEC-77   '+code+'      '+code+'   1\n']
    else:
        header = ['HEADER    mds alter z axis                        12-DEC-77   '+code+'      '+code+'   1\n']
    
    return S.save_with_remark(sname,  header = header)

def fix(dist,  N,  METRIC):
    
    V = 1.0
    W = 1.0
    
    if METRIC == 'CA':
        for i in range(N-1):
            C = max(dist[i,  i+1], dist[i+1,  i])+0.0
            if C> 3.8:
                V = max(V,  C/3.8)
            elif C < 3.8:
                W = min(W,  C/3.8)
    
    return None

def do_real(gdm,  N,  K=1.0):
    
    FACTOR = []
    f = open(FACTORING, 'r')
    row = f.readline()
    while row != '':
        i,  Dreal,  StDev = split(strip(row), ',')
        Dreal = float(Dreal)
        FACTOR.append(Dreal)
        row = f.readline()
    
    FACTOR1_2 = 6.01540
    FACTOR1_3 = 6.27780
    
    for i in range(N):
        for j in range(N):
            if abs(i-j) == 1:
                gdm[i][j] = FACTOR[0]
                ##############
            elif abs(i-j) == 2:
                gdm[i][j] = FACTOR1_2/K
            elif abs(i-j) >= 3:
                if int(gdm[i][j]) == 1:
                    gdm[i][j] = FACTOR1_3/K
                    ############
                else:
                    gdm[i][j] = FACTOR[int(gdm[i][j])]/K
    
    return gdm

def orng_mds(N, gdm_u,  dm,  amap,  SCALE=None,  ITER=10,  METRIC=None,  K=1.0):
    
    ###SCALE = 5.88
    ###SCALE = 6.00
    gdm = do_real(gdm_u,  N,  K)
    ####################
    ### unnecessary
    #
    """
    cm = zeros((N, N))
    for i in range(N):
        cm[i][i] = 1
        for j in range(i+1, N):
            if dm[i][j] <= 8.0:
                cm[i][j] = 1
                cm[j][i] = 1
    #"""
    ####################
    
    #dif = -1#9999999.0
    #old_dif = None
    #while dif != None:
    ###ITER=ITER*1000###fix!  Was:10
    ITER=100000
    dist = orange.SymMatrix(N) 
    
    for i in range(N): 
       for j in range(i+1): 
            #dist[i, j] = gdm[i][j]*SCALE
            dist[i, j] = gdm[i][j]
    
    #dist2 = fix(dist, N,  METRIC) no use
    
    print "running MDS with ITER="+str(ITER), 
    mds=orngMDS.MDS(dist, dim=3) 
    mds.run(ITER)
    
    #
    """
    if dm != None:
        atoms = mds2atoms(mds.points,  METRIC)
        mds_dm = dm_calc(atoms,  N)
        old_dif = dif
        ######################
        cm_mds = mds_dm < 8.0
        dif = sum(sum(logical_xor(cm,  cm_mds)))
        #dif = sum(sum(abs(dm - mds_dm)))*2/(N*(N-1))
        ######################
        print "dif=",  dif
    else:
        #no dm, no structure
        print "no structure"
        #dif = -1
        old_dif = 0
        ###SCALE = 5.1+0.1#5.07+0.0005*N, R2 = 0.076
        SCALE = 8.1+0.1
    
    if dif > old_dif:
    #if dif < old_dif:
    ITER=ITER*1000###fix!  Was:10
    #if abs(dif) < old_dif:
    #    mds=orngMDS.MDS(dist, dim=3) 
    #else:
    SCALE=SCALE+0.1#-0.1
    dist = orange.SymMatrix(N) 
    for i in range(N): 
        for j in range(i+1): 
            dist[i, j] = gdm[i][j]*SCALE
    mds=orngMDS.MDS(dist, dim=3) 
    print "re-running MDS with ITER="+str(ITER)+", SCALE="+str(SCALE), 
    mds.run(ITER)
    #"""
    ATOMS = mds2atoms(mds.points,  METRIC)
    mds_dm = dm_calc(ATOMS[0],  N)
    #dif = None
    #else:
    #SCALE=SCALE-0.1#+0.1

    print "Done. Finishing up..."
    
    return mds_dm,  None,  ATOMS,  None#old_dif

def tune(ATOMS):
    
    atoms,  atoms_a = ATOMS
    
    FACTOR = []
    f = open(FACTORING, 'r')
    i,  DIST,  STD = split(strip(f.readline()), ',')
    DIST = float(DIST)
    STDEV = float(STD)
    f.close()
    
    N = len(atoms)
    SUMDEV = 0.0
    AVGD = 0.0
    NDEV = 0
    for i in range(1, N):
        dist = atoms[i]-atoms[i-1]
        AVGD = AVGD + dist
        if abs(dist - DIST) > STDEV:
            SUMDEV = SUMDEV + abs(dist - DIST)
            NDEV = NDEV + 1
    AVGD = AVGD/(N - 1)
    NNDEV = NDEV
    OLDSUM = SUMDEV
    print "DIST=",  DIST,  "StDev=",  STDEV
    print "SumDev=",  SUMDEV,  "DeltaDev=", OLDSUM-SUMDEV, "NDev=",  NDEV,  "AVGDist=",  AVGD,  "AVGDev=",  SUMDEV/max(NDEV, 1)
    OLD_CURED = 0
    
    while NNDEV > 0:
        
        CNT = 0
        FIXED = []
        ACC_DEV = 50*STDEV
        
        while ACC_DEV > 0.1:
            
            cnt = 0
            for i in range(1, N - 1):
                
                a = atoms[i-1]
                b = atoms[i]
                c = atoms[i+1]
                
                if abs(abs(b - a) - DIST) < ACC_DEV and abs(abs(c - b) - DIST) < ACC_DEV:
                    continue
                
                cnt = cnt + 1
                if i not in FIXED:
                    FIXED.append(i)
                
                A = euclid.Vector3(a.get_vector()[0], a.get_vector()[1], a.get_vector()[2])
                B = euclid.Vector3(b.get_vector()[0], b.get_vector()[1], b.get_vector()[2])
                C = euclid.Vector3(c.get_vector()[0], c.get_vector()[1], c.get_vector()[2])
                
                AB = B - A
                AC = C - A
                Nv = AB.cross(AC)
                Nw = euclid.Vector3(0, 0, 1)
                Ctheta = Nv.dot(Nw)/Nv.magnitude()
                theta = arccos(Ctheta)
                Ax = Nv.cross(Nw)/Nv.magnitude()
                
                RM = euclid.Matrix4.new_rotate_axis(theta,  Ax)
                RM2 = euclid.Matrix4.new_rotate_axis(-1*theta,  Ax)
                
                A1 = RM*A
                B1 = RM*B
                C1 = RM*C
                x1, y1 = A1.x, A1.y
                x2, y2 = B1.x, B1.y
                x3, y3 = C1.x, C1.y
                
                AAA = ((x2-x1)*(y3-y1) - (x3-x1)*(y2-y1))/((x3*x3-x1*x1)*(x2-x1) + (x1-x3)*(x2*x2-x1*x1))
                BBB = (y2-y1 - AAA*(x2*x2 - x1*x1))/(x2 - x1)
                CCC = y1 - AAA*x1*x1 - BBB*x1
                
                DELTA = 0.0025
                DIR = 1
                
                q1 = 0
                q2 = 0
                if abs(abs(b - a) - DIST) > ACC_DEV and abs(abs(c - b) - DIST) > ACC_DEV:
                    if abs(abs(b - a) - DIST) > abs(abs(c - b) - DIST):
                        #ab
                        q1 = 1
                        if abs(b - a) < DIST:
                            #inc
                            if x1 > x2:
                                DIR = -1
                        elif x1 < x2:
                            #decr
                            DIR = -1
                    else:
                        #bc
                        q2 = 1
                        if abs(c - b) < DIST:
                            #inc
                            if x3 > x2:
                                DIR = -1
                        elif x3 < x2:
                            #decr
                            DIR = -1
                elif abs(abs(b - a) - DIST) > ACC_DEV :
                    #ab
                    q1 = 1
                    if abs(b - a) < DIST:
                        #inc
                        if x1 > x2:
                            DIR = -1
                    elif x1 < x2:
                        #decr
                        DIR = -1
                else:
                    #bc
                    q2 = 1
                    if abs(c - b) < DIST:
                        #inc
                        if x3 > x2:
                            DIR = -1
                    elif x3 < x2:
                        #decr
                        DIR = -1
                
                delta = DELTA*DIR
                x = x2
                old_x = x
                
                S1 = sqrt(pow(x - x1, 2)+pow(AAA*(x*x - x1*x1) + BBB*(x - x1), 2))
                S2 = sqrt(pow(x - x3, 2)+pow(AAA*(x*x - x3*x3) + BBB*(x - x3), 2))
                S = q1*S1 + q2*S2
                SX = (1-q1)*S1 + (1-q2)*S2
                SX_old = SX
                
                while abs(S - DIST) > STDEV and (abs(SX_old - DIST) >= abs(SX - DIST) or abs(SX - DIST) < 30*STDEV):
                    
                    old_x = x
                    x = x + delta
                    
                    SX_old = SX
                    S1 = sqrt(pow(x - x1, 2)+pow(AAA*(x*x - x1*x1) + BBB*(x - x1), 2))
                    S2 = sqrt(pow(x - x3, 2)+pow(AAA*(x*x - x3*x3) + BBB*(x - x3), 2))
                    S = q1*S1 + q2*S2
                    SX = (1-q1)*S1 + (1-q2)*S2
                    
                if abs(sqrt(pow(x - x1, 2)+pow(AAA*(x*x - x1*x1) + BBB*(x - x1), 2)) - DIST)+ abs(sqrt(pow(x - x3, 2)+pow(AAA*(x*x - x3*x3) + BBB*(x - x3), 2)) - DIST) < abs(sqrt(pow(old_x - x1, 2)+pow(AAA*(old_x*old_x - x1*x1) + BBB*(old_x - x1), 2)) - DIST) + abs(sqrt(pow(old_x - x3, 2)+pow(AAA*(old_x*old_x - x3*x3) + BBB*(old_x - x3), 2)) - DIST) :
                    B2 = euclid.Vector3(x, AAA*x*x + BBB*x + CCC, B1.z)
                else:
                    B2 = euclid.Vector3(old_x, AAA*old_x*old_x + BBB*old_x + CCC, B1.z)
                b2 = RM2*B2
                Z = array((b2.x,  b2.y,  b2.z))
                if B2.x == x2:
                    continue
                b22 = Atom('CA', Z,  1.0,  1.0,  1.0,  'CA',  str(i+1))
                if abs(b22-a - DIST) + abs(c-b22 - DIST) > abs(b-a - DIST) + abs(c-b - DIST):
                    continue
                atoms[i] = b22
            
            if cnt >0:
                SUMDEV = 0.0
                AVGD = 0.0
                NDEV = 0
                for i in range(1, N):
                    dist = atoms[i]-atoms[i-1]
                    AVGD = AVGD + dist
                    if abs(dist - DIST) > STDEV:
                        SUMDEV = SUMDEV + abs(dist - DIST)
                        NDEV = NDEV + 1
                AVGD = AVGD/(N - 1)
                
                CNT = CNT + cnt
                
                print cnt,  "moved",
                print "AccDev=", ACC_DEV, "SumDev=",  SUMDEV,  "DeltaDev=", OLDSUM-SUMDEV, "NDEV=",  NDEV,  "AVGDist=",  AVGD,  "AVGDev=",  SUMDEV/max(NDEV, 1)
                OLDSUM = SUMDEV
            
            ACC_DEV = ACC_DEV - STDEV
        
        print CNT,  "total moved",  len(FIXED),  "total fixed",  NNDEV-NDEV,  "total cured"
        if NNDEV-NDEV == OLD_CURED:
            NNDEV = 0
        OLD_CURED = NNDEV-NDEV

    atoms3 = []
    for i in range(N):
        w = atoms[i].get_vector().get_array()
        w[2] = -1*w[2]
        d = Atom('CA', w,  1.00,  1.00,  1.00,  'CA',  str(i+1))
        atoms3.append(d)

    return (atoms,  atoms3)

def get_diag(map,  N,  Full = False):
    
    SUM=[]
    for s in range(1, N):
        SUM.append(0.0)
        
    for i in range(N):
        for j in range(i+1, N):
            d = j-i
            SUM[d-1] = SUM[d-1] + map[i][j]
    
    AVG=[]
    for i in range(1, N):
        AVG.append(SUM[i-1]/(N-i))
    avg = AVG
    
    return avg

def differ(dm1,  dm2,  N):
    
    mat = dm1 - dm2
    for i in range(N):
        for j in range(i+1, N):
            mat[j][i] = mat[i][j]
    
    return mat

def savecsv(oname,  matrix,  N,  comma=','):
    
    f=open(oname, 'w')
    for i in range(N):
        line = ''
        for j in range(N):
            v = matrix[i][j]
            V = str(round(v, 3))
            line=line+V
            if j < N-1:
                line = line+comma
        line=line+'\n'
        f.write(line)
    
    f.close()

if __name__ == '__main__':
    
    from sys import argv
    
    if len(argv) < 2:
        print "usage: gdistance target [order metric separation RESID FORCE]"
        from sys import exit
        exit(len(argv))
    
    file_name = argv[1]
    if len(argv) < 3:
        ORDER2 = 25 
    else:
        ORDER2 = int(argv[2])
    if len(argv) < 4:
        METRIC = 'CA'
    else:
        METRIC = argv[3]
    if len(argv) < 5:
        SEPARATION = 0
    else:
        SEPARATION = int(argv[4])
    if len(argv) < 6:
        RESID = 0
    else:
        RESID = int(argv[5])
    if len(argv) < 7:
        FORCE = 0
    else:
        FORCE = int(argv[6])
    
    if len(argv) < 8:
        _STRUCT_ = 0
    else:
        _STRUCT_ = int(argv[7])
    #'pisces/'
    #DIR = '/home/michalp/genesilico/pdb/pisces/'
    
    ##############################
    ####DIR = '/home/michalp/genesilico/pdb/aln/'
    DIR = '/home2/db/pdb/' 
    ##############################
    
    MODE = 'w'
    CAT = '/home/michalp/gd_server/RR/BEST/MULTICOM/'
    #f = open(file_name, 'r')
    #GG = open(CAT+'factor8.csv', MODE)
    if MODE == 'w':
        s='pdb,L,POW,SCALE,MaxMDS-MaxDM,Log,Omax,Lmax,DIFF\n'
        #GG.write(s)

    ######################################
    ####TRANS flag###########################
    TRANS=False
    ######################################
    ######################################
    
    #PDB= f.readline()[:-1]
    PDB = CM_PRED_DIR+file_name+'.confuzz.casp.protmap.txt'
    while PDB != '':
        
        if PDB[0] == '#':
            PDB = f.readline()[:-1]
            continue
        
        #if not PDB[-4:] == 'casp':
        #if PDB[-3:] in ['pdb', 'ent']:
        #PDB = PDB[3:] 
	#PDB = PDB[:-4]	
	if _STRUCT_:
            #pdb
            if len(PDB) == 4:
                CHAIN=None
            elif len(PDB) == 5:
                CHAIN=PDB[4]
	    else:
		CHAIN = 'A'
            pdb = lower(PDB[:4])
            if CHAIN != None:
                pdb=pdb+CHAIN
            code = lower(PDB[:4])
            
            ###contact map
            pdbfile =code+'.pdb'
            #file_name = DIR+pdbfile
	    file_name = DIR+'pdb'+code+'.ent'
            #if pdbfile not in listdir(DIR):
            #    system('wget http://www.rcsb.org/pdb/files/'+code+'.pdb.gz -O '+file_name+'.gz')
            #    system('gunzip '+file_name+'.gz')
            try:
                cm,  resnames,  N,  D = make_contact_map(file_name,  CHAIN, METRIC, SEPARATION,  RESID,  FORCE)
            except KeyError,  message:
                if str(message)[1:-1] == METRIC:
                    print 'KeyError:', str(message)
                    PDB = f.readline()[:-1]
                    continue
                else:
                    raise
            except Exception,  m:
                if str(m) == 'gapped' or str(m) == 'long':
                    #gapped structure
                    PDB = f.readline()[:-1]
                    continue
                raise
                
            seq = get_seqrecord(resnames)
            
            ###distance map
            print "running dm..."
            (list,  map) = D
            amap = map[0]
            
            dm = dm_calc(mds2atoms(list[0],  METRIC)[0],  N,  amap)
            rowdata = encode_protmap(dm,  seq,  None,  None,  8,  None,  None,  None)
            oname = CAT+file_name+METRIC+'.lfactor.'+str(RESID)+'.'
            oname2 = oname+'dm.txt'
            savef(oname2,  rowdata)
            
        else:
            #casp cm
            dm = None
            try:
                cm,  resnames,  N,  D  = read_contacts(PDB)
            except Exception,  msg:
                print str(msg)
                raise
                #PDB = f.readline()[:-1]
                continue
            
            seq = get_seqrecord(resnames)
            
            pdb = PDB[26:-25]
            
            amap = range(N)
            oname = CAT+pdb+METRIC+'.'+str(ORDER2) +'.lfactor.'
 
        #norder = natural_order(L)THRESHOLD
        ###
        #cm2,  O,  Lf = refine(cm,  N,  ORDER2,  TRANS=TRANS)
       	cm2 = cm
        ###
 
        if dm != None and TRANS==False:
            cm2 = cm
            print "no refinement made"
            for i in range(N):
                cm2[i][i] = 1.0
        rowdata = encode_protmap(cm2,  seq,  None,  None,  8,  None,  None,  None)
        oname0 = oname +'cm.txt'
        savef(oname0,  rowdata)
        
        ########################
        #PDB = ''
        #PDB = f.readline()[:-1]
        #continue
        ########################
        
        
        ###distance graph
        diff,  POW,  LOG,  K  = cm_power(cm2,  N, amap)
        
        if POW == __MAXPOW__:
            #PDB = f.readline()[:-1]
            #continue
       	    pass 
        cmi = diff#cmi = diff - 1
        rowdata = encode_protmap(cmi,  seq,  None,  None,  8,  None,  None,  None)
        oname2 = oname+'pdm.txt'
        savef(oname2,  rowdata)
       	print oname0
        ###mds
        mds,  SCALE,  atoms,  DIFF = orng_mds(N,  cmi,  dm,  amap,  METRIC=METRIC,  K=K)
        rowdata = encode_protmap(mds,  seq,  None,  None,  8,  None,  None,  None)
        oname3 = oname+'mds.txt'
        savef(oname3,  rowdata)
        
        struct = encode_smcra(atoms[0],  seq,  oname+'mds_raw.pdb')
        struct2 = encode_smcra(atoms[1],  seq,  oname+'mds_raw.a.pdb',  alter=True)
        
        atoms2 = tune(atoms)
        
        struct3 = encode_smcra(atoms2[0],  seq,  oname+'mds.pdb')
        struct4 = encode_smcra(atoms2[1],  seq,  oname+'mds.a.pdb',  alter=True)
        
        if dm != None:
            M_dm = max(max(dm))
        else:
            M_dm = 0
        
        M_mds = max(max(mds))
        D2 = M_mds-M_dm
        #s=pdb+','+str(N)+','+str(POW)+','+str(SCALE)+','+str(round(D2,1))+','+str(int(round(LOG, 0)))+','+str(int(O))+','+str(round(Lf, 2))+','+str(DIFF)+'\n'
        #GG.write(s)
        
        if dm != None:
            dif = differ(dm, mds,  N)
            oname4 = oname+'diff.csv'
            #savecsv(oname4,  dif,  N)
        
        #PDB = f.readline()[:-1]
	PDB = ''
