#!/usr/bin/python
# Import smtplib for the actual sending function
import smtplib

# Import the email modules we'll need
from email.mime.text import MIMEText

import os
from email.MIMEMultipart import MIMEMultipart
from email.MIMEBase import MIMEBase
from email.MIMEText import MIMEText
from email.Utils import COMMASPACE, formatdate
from email import Encoders

from string import replace

FROM = 'gdserver@genesilico.pl'

from sys import argv
if len(argv) < 3:
	print "usage: send_confuzz target recipient"
	from sys import exit
	exit(1)
	
target = argv[1]
TO = argv[2]

pdbfile = target+'.confuzz.3d.pdb'
subject = 'GDserver 3D prediction results: '+target

# Open a plain text file for reading.  For this example, assume that
# the text file contains only ASCII characters.

###fp = open('../server/'+pdbfile, 'rb')
# Create a text/plain message
###msg = MIMEText(fp.read())
msg = MIMEMultipart()
###fp.close()

text = """<html><head></head><body><p>Thank You for using GDFuzz3D service!<br><br><a href="http://genesilico.pl/protmap2d.htm">PROTMAP2D</a> - a tool for visualization, comparison and analysis of 2D maps of protein structure<br><a href="http://www.pymol.org/">PyMOL</a> - protein 3D structures' molecular visualization system.<br><br>Attachments: *.pdb - final full-atom model, *.mds.txt - intermediate distance map.</p></body></html>"""
msg.attach( MIMEText(text, 'html') )

part = MIMEBase('application', "octet-stream")
part.set_payload( open('../server/'+pdbfile,"rb").read() )
Encoders.encode_base64(part)
part.add_header('Content-Disposition', 'attachment; filename="%s"' % os.path.basename('../server/'+pdbfile))
msg.attach(part)

dmfile = replace(pdbfile,'.confuzz.3d.pdb','CA.25.lfactor.mds.txt')

part = MIMEBase('application', "octet-stream")
part.set_payload( open('../gd_server/RR/BEST/MULTICOM/'+dmfile,"rb").read() )
Encoders.encode_base64(part)
part.add_header('Content-Disposition', 'attachment; filename="%s"' % os.path.basename('../gd_server/RR/BEST/MULTICOM/'+dmfile))
msg.attach(part)

# me == the sender's email address
# you == the recipient's email address
msg['Subject'] = subject
msg['From'] = FROM
msg['To'] = TO

# Send the message via our own SMTP server, but don't include the
# envelope header.
s = smtplib.SMTP()
s.connect()
s.sendmail(FROM, [TO], msg.as_string())
s.quit()

import time
y, m, d, h, mi, s, a, b, c = time.gmtime()
#h = h + 2
#GMT time
timestr = str(y)+' '+str(m)+' '+str(d)+' '+str(h)+' '+str(mi)+' '+str(s)
ff = open('../gd_server/pdblist.log','aw')
ff.write(target+' '+timestr+'\n')
ff.close()

from os import system
system('cp ../server/'+pdbfile+' /home/michalp/server/SENT/')

print pdbfile, "sent at", timestr
